package com.ustadmobile.core.db.dao

import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.paging.DataSourceFactory
import com.ustadmobile.door.room.RoomDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import com.ustadmobile.lib.db.entities.LearnerGroup
import kotlin.IllegalStateException
import kotlin.Int
import kotlin.Long
import kotlin.Unit
import kotlin.collections.List

public class LearnerGroupDao_ReplicateWrapper(
  private val _db: RoomDatabase,
  private val _dao: LearnerGroupDao,
) : LearnerGroupDao() {
  public override suspend fun replicateOnNewNode(newNodeId: Long): Unit {
    _dao.replicateOnNewNode(newNodeId)
  }

  public override suspend fun replicateOnChange(): Unit {
    _dao.replicateOnChange()
  }

  public override fun findGroupsForEntryAsync(contentEntryUid: Long):
      DataSourceFactory<Int, LearnerGroup> = _dao.findGroupsForEntryAsync(contentEntryUid)

  public override fun findGroupListForEntry(contentEntryUid: Long): List<LearnerGroup> = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override fun insert(entity: LearnerGroup): Long = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override suspend fun insertAsync(entity: LearnerGroup): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entity.learnerGroupUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(301)
      entity.learnerGroupUid = _newPk
    }
    entity.learnerGroupLct = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(entity)
    return entity.learnerGroupUid
  }

  public override fun insertList(entityList: List<LearnerGroup>): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override fun updateList(entityList: List<LearnerGroup>): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override fun update(entity: LearnerGroup): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")
}
