package com.ustadmobile.core.db.dao

import com.ustadmobile.door.lifecycle.LiveData
import com.ustadmobile.lib.db.entities.ScrapeQueueItem
import com.ustadmobile.lib.db.entities.ScrapeQueueItemWithScrapeRun
import kotlin.Int
import kotlin.Long
import kotlin.String
import kotlin.Unit
import kotlin.collections.List

public actual abstract class ScrapeQueueItemDao : BaseDao<ScrapeQueueItem> {
  public actual abstract fun findNextQueueItems(itemType: Int): LiveData<List<ScrapeQueueItem>>

  public actual abstract fun updateSetStatusById(
    uid: Int,
    status: Int,
    errorCode: Int,
  ): Unit

  public actual abstract fun getExistingQueueItem(runId: Int, indexUrl: String): ScrapeQueueItem?

  public actual abstract fun findExistingQueueItem(runId: Int, entryUid: Long): ScrapeQueueItem?

  public actual abstract fun setTimeStarted(uid: Int, timeStarted: Long): Unit

  public actual abstract fun setTimeFinished(uid: Int, timeFinished: Long): Unit

  public actual abstract fun findByUid(sqiUid: Int): ScrapeQueueItemWithScrapeRun?
}
