package com.ustadmobile.core.db.dao

import com.ustadmobile.lib.db.entities.Holiday
import kotlin.Boolean
import kotlin.Long
import kotlin.Unit
import kotlin.collections.List

public actual abstract class HolidayDao : BaseDao<Holiday>, OneToManyJoinDao<Holiday> {
  public actual abstract suspend fun replicateOnNewNode(newNodeId: Long): Unit

  public actual abstract suspend fun replicateOnChange(): Unit

  public actual abstract fun findByHolidayCalendaUid(holidayCalendarUid: Long): List<Holiday>

  public actual abstract suspend fun findByHolidayCalendaUidAsync(holidayCalendarUid: Long):
      List<Holiday>

  public actual abstract fun updateActiveByUid(
    holidayUid: Long,
    active: Boolean,
    changeTime: Long,
  ): Unit

  public actual abstract suspend fun updateAsync(entity: Holiday): Unit
}
